<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional Edition 2008.0                             |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 9                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage System
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */
class system
{
	
	function statusbar( $var, $var2 )
	{
		global $user, $templates, $preferences;
		
		if( ( $user[ 'user_username' ] ) && ( $user[ 'user_session' ] ) )
		{
			$insert[ 'user_username' ] = $user[ 'user_username' ];
			$bar = $templates -> exectemplate( $var[ 'site_login_user_html' ], $var[ 'site_login_user_php' ], $insert );
		}
		else
		{
			$bar = $templates -> exectemplate( $var[ 'site_login_anon_html' ], $var[ 'site_login_anon_php' ], $var2 );
		}
		
		return $bar;
	}

	function getstatus()
	{
		global $user, $database;
		
		if( ( $user[ 'user_username' ] ) && ( $user[ 'user_session' ] ) )
		{
			$query = $database -> dbquery( "SELECT user_status FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '". $user[ 'user_username' ] ."'" );
			list( $status ) = $database -> dbrow( $query );
		}
		else
		{
			$status = 0;
		}
		
		return $status;
	}

	function getdir( $var )
	{
		$dir = array();
		$file = "";
		
		if( file_exists( "$var" ) )
		{
			$od = opendir( $var );
			
			while( $file = readdir( $od ) )
			{
				array_push( $dir, "$file" );
			}
			
			closedir( $od );
			sort( $dir );
		}
		
		return $dir;
	}

	function description( $var )
	{
		$var = eregi_replace( "\\[([^\\[]*)\\]", "", strip_tags( $var ) );
		if( phpversion() >= "4.3.0" )
		{
			$var = html_entity_decode( $var );
			$var = htmlspecialchars( $var );
		}
		$var = str_replace( "\r\n", " ", $var );
		$var = substr( $var, 0, 200 ) . "...";
		return $var;
	}

	function keywords( $var )
	{
		$keywords = array();
		if( phpversion() >= "4.3.0" )
		{
			$var = html_entity_decode( $var );
			$var = htmlspecialchars( $var );
		}
		$words = explode( " ", eregi_replace( "\\[([^\\[]*)\\]", "", strip_tags( $var ) ) );
		
		for( $i = 0; $i < count( $words ); $i++ )
		{
			if( strlen( $words[ $i ] ) > 3 )
			{
				$keywords[ ] = $words[ $i ];
			}
		}
		
		sort( $keywords );
		$linewords = 0;
		$returndata = 0;
		
		for( $i = 0; $i < count( $keywords ); $i++ )
		{
			if( ( @!preg_match( "/" . $keywords[ $i ] . "/", $returndata ) ) and( @!preg_match( "/^\W|,|\"|\.|\n|<|>|'|\/|!|\)|\(|:|;/i", $keywords[ $i ] ) ) )
			{
				if( $linewords < 60 )
				{
					$returndata .= $keywords[ $i ] . ", ";
					$linewords++;
				}
			}
		}
		
		$returndata = substr( $returndata, 1, -2 );
		return $returndata;
	}

	function tags( $var )
	{
		$tags = array();
		if( phpversion() >= "4.3.0" )
		{
			$var = html_entity_decode( $var );
			$var = htmlspecialchars( $var );
		}		
		$words = explode( " ", eregi_replace( "\\[([^\\[]*)\\]", "", strip_tags( $var ) ) );
		
		for( $i = 0; $i < count( $words ); $i++ )
		{
			if( strlen( $words[ $i ] ) > 5 and !preg_match( "/[0-9]/i", $words[ $i ] ) )
			{
				$tags[ ] = $words[ $i ];
			}
		}
		
		sort( $tags );
		$returndata = implode( ",", $tags );
		return $returndata;
	}

	function fixbreaks( $var )
	{
		$var = str_replace( "\n", "\\n", $var );
		return $var;
	}

	function convertbreaks( $var )
	{
		$var = str_replace( "\n", "<br />", $var );
		return $var;
	}

	function smilies( $var )
	{
		global $smilie_command_cache, $smilie_image_cache, $database;
		
		if( !is_array( $smilie_command_cache ) )
		{
			$query = $database -> dbquery( "SELECT smilie_command, smilie_image FROM " . DB_PREFIX . "esselbach_ct_smilies WHERE smilie_active = '1'" );
			
			while( list( $command, $image ) = mysql_fetch_row( $query ) )
			{
				$smilie_command_cache[ ] = $command;
				$smilie_image_cache[ ] = $image;
			}
		}
		
		for( $i = 0; $i < count( $smilie_command_cache ); $i++ )
		{
			$var = str_replace( $smilie_command_cache[ $i ], " <img src=\"images/smilies/" . $smilie_image_cache[ $i ] . "\" alt=\"" . $smilie_command_cache[ $i ] . "\" />", $var );
		}
		
		return $var;
	}

	function code( $var )
	{
		global $system, $database;
		$var = $system -> checkcode( "[quote]", "[/quote]", $var );
		$var = $system -> checkcode( "[code]", "[/code]", $var );
		$var = $system -> checkcode( "[b]", "[/b]", $var );
		$var = $system -> checkcode( "[i]", "[/i]", $var );
		$var = $system -> checkcode( "[u]", "[/u]", $var );
		$var = $system -> checkcode( "[marquee]", "[/marquee]", $var );
		$var = $system -> checkcode( "[s]", "[/s]", $var );
		$var = $system -> checkcode( "[sup]", "[/sup]", $var );
		$var = $system -> checkcode( "[sub]", "[/sub]", $var );
		$var = $system -> checkcode( "[tt]", "[/tt]", $var );
		$var = $system -> checkcode( "[center]", "[/center]", $var );
		$var = $system -> checkcode( "[left]", "[/left]", $var );
		$var = $system -> checkcode( "[right]", "[/right]", $var );
		$query = $database -> dbquery( "SELECT code_search, code_replace FROM " . DB_PREFIX . "esselbach_ct_blockcode WHERE code_active = '1'" );
		
		if( $database -> dbrows( $query ) )
		{
			while( list( $search, $replace ) = $database -> dbrow( $query ) )
			{
				$var = str_replace( $search, $replace, $var );
			}
		}
		
		$var = str_replace( array( "[quote]", "[/quote]", "[code]", "[/code]", "[b]", "[/b]", "[i]", "[/i]", "[u]", "[/u]", "[marquee]", "[/marquee]", "[s]", "[/s]", "[sup]", "[/sup]", "[sub]", "[/sub]", "[tt]", "[/tt]", "[center]", "[/center]", "[left]", "[/left]", "[right]", "[/right]" ), array( "<table class=\"quoteblock\"><tr><td>", "</td></tr></table>", "<table class=\"codeblock\"><tr><td><pre>", "</pre></tr></td></table>", "<strong>", "</strong>", "<i>", "</i>", "<u>", "</u>", "<marquee>", "</marquee>", "<s>", "</s>", "<sup>", "</sup>", "<sub>", "</sub>", "<tt>", "</tt>", "<center>", "</center>", "<p align=\"left\">", "</p>", "<p align=\"right\">", "</p>" ), $var );
		$var = preg_replace( "/\[url\](.*?)\[\/url\]/", "<a href=\"\\1\" rel=\"nofollow\">\\1</a>", $var );
		$var = eregi_replace( "\\[img\\]([^\\[]*)\\[/img\\]", "<img src=\"\\1\" alt=\"\" />", $var );
		$var = eregi_replace( "\\[imgleft\\]([^\\[]*)\\[/imgleft\\]", "<img src=\"\\1\" border=\"0\" align=\"left\" hspace=\"10\" vspace=\"10\">", $var );
		$var = eregi_replace( "\\[imgright\\]([^\\[]*)\\[/imgright\\]", "<img src=\"\\1\" border=\"0\" align=\"right\" hspace=\"10\" vspace=\"10\">", $var );
		$var = eregi_replace( "\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\1</a>", $var );
		$var = eregi_replace( "\\[url=http://([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", $var );
		$var = eregi_replace( "\\[url=www.([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" rel=\"nofollow\">\\2</a>", $var );
		$var = eregi_replace( "\\[url=https://([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"https://\\1\" rel=\"nofollow\">\\2</a>", $var );
		$var = eregi_replace( "\\[url=ftp://([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"ftp://\\1\" rel=\"nofollow\">\\2</a>", $var );
		$var = eregi_replace( "\\[url=ftp.([^\\[]+)\\]([^\\[]*)\\[/url\\]", "<a href=\"ftp://ftp.\\1\" rel=\"nofollow\">\\2</a>", $var );
		$var = eregi_replace( "\\[email=([^\\[]+)\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\" rel=\"nofollow\">\\2</a>", $var );
		$var = eregi_replace( "\\[size=([^\\[]+)\\]([^\\[]*)\\[/size\\]", "<font size=\"\\1\">\\2</font>", $var );
		$var = eregi_replace( "\\[font=([^\\[]+)\\]([^\\[]*)\\[/font\\]", "<font face=\"\\1\">\\2</font>", $var );
		$var = eregi_replace( "\\[color=([^\\[]+)\\]([^\\[]*)\\[/color\\]", "<font color=\"\\1\">\\2</font>", $var );
		return $var;
	}

	function fixsmilies( $var )
	{
		$var = str_replace( " <img src=\"images/smilies/", " <img src=\"../images/smilies/", $var );
		return $var;
	}	

	function getvariables()
	{
		global $preferences;
		$request = str_replace( $preferences[ 'website_url' ], "", "http://" . $_SERVER[ 'SERVER_NAME' ] . $_SERVER[ 'REQUEST_URI' ] );
		$variable_array = array();
		
		if ( $preferences[ 'website_mod_rewrite' ] )
		{
			$request = "/contentteller" . $request;
		}
		if( preg_match( "/\/contentteller/i", $request ) )
		{
			$index = 1;
			$variable_array = explode( "/", $request );
			
			for( $data = 0; $data < count( $variable_array ) ; $data++ )
			{
				if( md5( $variable_array[ $data ] ) == "e97090cf2bebac6ece11a3000377a273" or md5( $variable_array[ $data ] ) == "22d3d74765fce2e31efbcf33129798e7" )
				{
					$index = $index + $data;
				}
			}
			
			array_splice( $variable_array, 0, $index );
			
			if( isset( $variable_array[ 2 ] ) )
			{
				if( preg_match( "/html/i", $variable_array[ 2 ] ) )
				{
					$split = explode( "-", $variable_array[ 2 ] );
					$variable_array[ 2 ] = $split[ 0 ];
				}
			}
		}
		
		return $variable_array;
	}

	function checkcode( $var, $var2, $var3 )
	{
		global $system;
		$code_open = $system -> supercount( $var, $var3 );
		$code_close = $system -> supercount( $var2, $var3 );
		
		if( $code_open != $code_close )
		{
			$var3 = str_replace( $var, "", $var3 );
			$var3 = str_replace( $var2, "", $var3 );
		}
		
		return $var3;
	}

	function convertdate( $var, $var2, $var3 )
	{
		$story_date_array = explode( " ", $var );
		$story_date = explode( "-", $story_date_array[ 0 ] );
		$story_time = explode( ":", $story_date_array[ 1 ] );
		$story_date = mktime( $story_time[ 0 ], $story_time[ 1 ], $story_time[ 2 ], $story_date[ 1 ], $story_date[ 2 ], $story_date[ 0 ] );
		$offset_minutes = substr( $var3, 1, 1 ) * 60;
		$offset_seconds = $offset_minutes * 60;
		
		if( substr( $var3, 0, 1 ) == "+" )
		{
			$story_date = $story_date + $offset_seconds;
		}
		elseif( substr( $var3, 0, 1 ) == "-" )
		{
			$story_date = $story_date - $offset_seconds;
		}
		
		return gmstrftime( $var2, $story_date );
	}

	function getmonth( $var )
	{
		$story_date_array = explode( " ", $var );
		$story_date = explode( "-", $story_date_array[ 0 ] );
		$var = $story_date[ 0 ] . $story_date[ 1 ];
		return $var;
	}

	function decode( $var )
	{
		$var = htmlspecialchars( base64_decode( $var ) );
		return $var;
	}

	function write( $var )
	{
		header( "Content-Type: image/png" );
		echo base64_decode( $var );
		exit;
	}

	function scriptex( $var )
	{
		$var = preg_replace( "/javascript/i", "java&nbsp;script&nbsp;", $var );
		$var = preg_replace( "/vbscript/i", "vb&nbsp;script&nbsp;", $var );
		$var = preg_replace( "/about:/i", "about&nbsp;:", $var );
		$var = preg_replace( "/JavaScript/i", "Java&nbsp;Script&nbsp;", $var );
		$var = preg_replace( "/VBScript/i", "vb&nbsp;script&nbsp;", $var );
		return $var;
	}

	function dechomp( $var )
	{
		$var = str_replace( "\r\n", "<br />", htmlspecialchars( $var ) );
		return $var;
	}

	function rechomp( $var )
	{
		$var = str_replace( "<br />", "\n", $var );
		$var = str_replace( "&lt;", "<", $var );
		$var = str_replace( "&gt;", ">", $var );
		return $var;
	}

	function getip()
	{
		$var = addslashes( $_SERVER[ "REMOTE_ADDR" ] );
		return $var;
	}

	function getreferrer()
	{
		$var = addslashes( $_SERVER[ "HTTP_REFERER" ] );
		return $var;
	}

	function getagent()
	{
		$var = addslashes( $_SERVER[ "HTTP_USER_AGENT" ] );
		return $var;
	}

	function resizeimage( $var, $var2, $var3, $var4, $var5 )
	{
		if( function_exists( "imagecreatefromstring" ) )
		{
			$contentfile_image = imagecreatefromstring( $var );
			$contentfile_width = imagesx( $contentfile_image );
			$contentfile_height = imagesy( $contentfile_image );
			$contentfile_twidth = $var3;
			
			if( $contentfile_twidth > $contentfile_width )
			{
				$contentfile_twidth = $contentfile_width;
			}
			
			$contentfile_theight = ceil( $contentfile_height*$contentfile_twidth/$contentfile_width );
			
			if( function_exists( "imagecreatetruecolor" ) )
			{
				$contentfile_thumb = imagecreatetruecolor( $contentfile_twidth, $contentfile_theight );
			}
			else
			{
				$contentfile_thumb = imagecreate( $contentfile_twidth, $contentfile_theight );
			}
			
			$contentfile_background = imagecolorallocate( $contentfile_thumb, 255, 255, 255 );
			imagefill( $contentfile_thumb, 0, 0, $contentfile_background );
			imagecopyresized( $contentfile_thumb, $contentfile_image, 0, 0, 0, 0, $contentfile_twidth, $contentfile_theight, $contentfile_width, $contentfile_height );
			
			if( $var4 )
			{
				if( $var5 == "White" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 255, 255, 255 );
				}
				
				if( $var5 == "Block" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 0, 0, 0 );
				}
				
				if( $var5 == "Red" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 255, 0, 0 );
				}
				
				if( $var5 == "Green" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 0, 255, 0 );
				}
				
				if( $var5 == "Blue" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 12, 0, 253 );
				}
				
				if( $var5 == "Yellow" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 254, 239, 0 );
				}
				
				if( $var5 == "Purple" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 102, 0, 153 );
				}
				
				if( $var5 == "Cyan" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 0, 254, 239 );
				}
				
				imagestring( $contentfile_thumb, 4, 1,( $contentfile_theight - 16 ), $var4, $textcolor );
			}
			
			ob_start();
			
			if( preg_match( "/jpeg/i", $var2 ) )
			{
				imagejpeg( $contentfile_thumb );
			}
			
			if( preg_match( "/gif/i", $var2 ) and function_exists( "imagegif" ) )
			{
				imagegif( $contentfile_thumb );
			}
			
			if( preg_match( "/png/i", $var2 ) )
			{
				imagepng( $contentfile_thumb );
			}
			
			$image_data = ob_get_contents();
			ob_end_clean();
			
			if( !function_exists( "imagegif" ) )
			{
				$image_data = "";
			}
		}
		else
		{
			$image_data = "";
		}
		
		return $image_data;
	}

	function stripthis( $var )
	{
		if( get_magic_quotes_gpc() )
		{
			$var = stripslashes( $var );
		}
		
		return $var;
	}

	function stripthisarray( $var )
	{
		for( $i = 0; $i < count( $var ); $i++ )
		{
			if( isset( $var[ $i ] ) )
			{
				if( get_magic_quotes_gpc() )
				{
					$var[ $i ] = stripslashes( $var[ $i ] );
				}
			}
		}
		
		return $var;
	}

	function hashpass( $var )
	{
		if( phpversion() >= "4.3.0" )
		{
			$var = sha1( $var );
		}
		else
		{
			$var = md5( $var );
		}
		
		return $var;
	}
	
	function supercount( $var, $var2 )
	{
		$var = str_replace( "/", "Un", $var );
		$var = str_replace( "[", "Lf", $var );
		$var = str_replace( "]", "Rg", $var );
		$var2 = str_replace( "/", "Un", $var2 );
		$var2 = str_replace( "[", "Lf", $var2 );
		$var2 = str_replace( "]", "Rg", $var2 );
		$myarray = preg_split( "/[\s,]+/", $var2 );
		$found = 0;
		
		for( $i = 0; $i < count( $myarray ); $i++ )
		{
			if( preg_match( "/" . $var . "/i", $myarray[ $i ] ) )
			{
				$found++;
			}
		}
		
		return $found;
	}

	function stats()
	{
		global $config, $security, $database, $preferences, $user, $ipaddr;
		$stats_month = date( "m" );
		$stats_year = date( "Y" );
		$stats_url = ( isset( $_SERVER[ 'HTTP_REFERER' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_REFERER' ] ) : "" ;
		$stats_agent = ( isset( $_SERVER[ 'HTTP_USER_AGENT' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_USER_AGENT' ] ) : "" ;
		$stats_query = ( isset( $_SERVER[ 'REQUEST_URI' ] ) ) ? $security -> checkvar( $_SERVER[ 'REQUEST_URI' ] ) : "" ;
		$query = $database -> dbquery( "SELECT statcount_id FROM " . DB_PREFIX . "esselbach_ct_statscounter WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );
		
		if( $database -> dbrows( $query ) )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statscounter SET statcount_pageviews = statcount_pageviews + 1 WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
		}
		else
		{
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statscounter (statcount_id, statcount_website, statcount_month, statcount_year, statcount_pageviews, statcount_rssviews) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '1', '0')" );
		}
		
		if( $preferences[ 'website_stats_referrers' ] )
		{
			$preferences[ 'alt_website_url' ] = str_replace( "www.", "", $preferences[ 'website_url' ] );
			
			if( ( $stats_url ) and( substr( $stats_url, 0, strlen( $preferences[ 'website_url' ] ) ) != $preferences[ 'website_url' ] ) and( substr( $stats_url, 0, strlen( $preferences[ 'alt_website_url' ] ) ) != $preferences[ 'alt_website_url' ] ) )
			{
				if ( !preg_match( "/google|msn|yahoo|lycos|live|jeeves|translate_c|q=cache/i", $stats_url ) )
				{
					$query = $database -> dbquery( "SELECT statreferrer_id FROM " . DB_PREFIX . "esselbach_ct_statsreferrers WHERE statreferrer_month = '" . $stats_month . "' AND statreferrer_year = '" . $stats_year . "' AND statreferrer_url = '" . $stats_url . "' AND statreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );
					
					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsreferrers SET statreferrer_count = statreferrer_count + 1 WHERE statreferrer_month = '" . $stats_month . "' AND statreferrer_year = '" . $stats_year . "' AND statreferrer_url = '" . $stats_url . "' AND statreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsreferrers (statreferrer_id, statreferrer_website, statreferrer_month, statreferrer_year, statreferrer_url, statreferrer_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_url . "', '1')" );
					}
				}
			}
		}
		
		if( $preferences[ 'website_stats_browsers' ] )
		{
			$query = $database -> dbquery( "SELECT statbrowser_id FROM " . DB_PREFIX . "esselbach_ct_statsbrowsers WHERE statbrowser_month = '" . $stats_month . "' AND statbrowser_year = '" . $stats_year . "' AND statbrowser_agent = '" . $stats_agent . "' AND statbrowser_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );
			
			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsbrowsers SET statbrowser_count = statbrowser_count + 1 WHERE statbrowser_month = '" . $stats_month . "' AND statbrowser_year = '" . $stats_year . "' AND statbrowser_agent = '" . $stats_agent . "' AND statbrowser_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsbrowsers (statbrowser_id, statbrowser_website, statbrowser_month, statbrowser_year, statbrowser_agent, statbrowser_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_agent . "', '1')" );
			}
		}
		
		if( $preferences[ 'website_stats_bots' ] )
		{
			if( preg_match( "/Google|Yahoo|MSNBOT|lycos|Lycos|av\.com|live|jeeves|Twiceler/i", $stats_agent ) )
			{
				if( preg_match( "/Mediapartners/i", $stats_agent ) )
				{
					$stats_bot = 2;
				}
				elseif( preg_match( "/Google/i", $stats_agent ) )
				{
					$stats_bot = 1;
				}
				elseif( preg_match( "/Yahoo/i", $stats_agent ) )
				{
					$stats_bot = 3;
				}
				elseif( preg_match( "/MSNBOT/i", $stats_agent ) )
				{
					$stats_bot = 4;
				}
				elseif( preg_match( "/lycos|Lycos/i", $stats_agent ) )
				{
					$stats_bot = 5;
				}
				elseif( preg_match( "/av\.com/i", $stats_agent ) )
				{
					$stats_bot = 6;
				}
				elseif( preg_match( "/jeeves/i", $stats_agent ) )
				{
					$stats_bot = 7;
				}
				elseif( preg_match( "/live/i", $stats_agent ) )
				{
					$stats_bot = 8;
				}
				elseif( preg_match( "/Twiceler/i", $stats_agent ) )
				{
					$stats_bot = 9;
				}				
				
				if( $stats_query )
				{
					$query = $database -> dbquery( "SELECT statbot_id FROM " . DB_PREFIX . "esselbach_ct_statsbots WHERE statbot_month = '" . $stats_month . "' AND statbot_year = '" . $stats_year . "' AND statbot_bot = '" . $stats_bot . "' AND statbot_query = '" . $stats_query . "' AND statbot_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );
					
					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsbots SET statbot_count = statbot_count + 1 WHERE statbot_month = '" . $stats_month . "' AND statbot_year = '" . $stats_year . "' AND statbot_bot = '" . $stats_bot . "' AND statbot_query = '" . $stats_query . "' AND statbot_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsbots (statbot_id, statbot_website, statbot_month, statbot_year, statbot_bot, statbot_query, statbot_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_bot . "', '" . $stats_query . "', '1')" );
					}
				}
			}
		}
		
		if( $preferences[ 'website_stats_onlineusers' ] )
		{
			$current_time = time();
			$current_session = time() - intval( $preferences[ 'website_stats_onlinetime' ] );
			
			if( $user[ 'user_status' ] )
			{
				$online_user = $database -> dbescape( $user[ 'user_name' ] );
				$online_invisible = $database -> dbescape( $user[ 'user_invisible' ] );
				$online_bot = 0;
			}
			else
			{
				$online_user = "";
				$online_invisible = 0;
				
				if( preg_match( "/Google/i", $stats_agent ) )
				{
					$stats_bot = "Google";
				}
				elseif( preg_match( "/Yahoo/i", $stats_agent ) )
				{
					$stats_bot = "Yahoo";
				}
				elseif( preg_match( "/MSNBOT/i", $stats_agent ) )
				{
					$stats_bot = "MSN";
				}
				elseif( preg_match( "/lycos|Lycos/i", $stats_agent ) )
				{
					$stats_bot = "Lycos";
				}
				elseif( preg_match( "/av\.com/i", $stats_agent ) )
				{
					$stats_bot = "Altavista";
				}
				elseif( preg_match( "/jeeves/i", $stats_agent ) )
				{
					$stats_bot = "Ask Jeeves";
				}
				elseif( preg_match( "/live/i", $stats_agent ) )
				{
					$stats_bot = "Live Search";
				}
				elseif( preg_match( "/Twiceler/i", $stats_agent ) )
				{
					$stats_bot = "Cuil";
				}				
				else
				{
					$stats_bot = "";
				}
				
				if( $stats_bot )
				{
					$online_user = $stats_bot;
					$online_bot = 1;
				}
				else
				{
					$online_bot = 0;
				}
			}
			
			$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_online WHERE online_time < ('" . $current_session . "') OR online_ip ='" . $ipaddr . "'" );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_online (online_time, online_website, online_user, online_invisible, online_bot, online_ip) VALUES ('" . $current_time . "', '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $online_user . "', '" . $online_invisible . "', '" . $online_bot . "', '" . $ipaddr . "')" );
		}
		
		if( isset ( $preferences[ 'contacts_stats_referrers' ] ) )
		{
			if( $preferences[ 'contacts_stats_referrers' ] and $stats_url )
			{
				$found = 0;
				$query = $database -> dbquery( "SELECT contact_domain FROM " . DB_PREFIX . "esselbach_ct_contacts" );
				
				while( list( $contact_domain ) = $database -> dbrow( $query ) )
				{
					if( preg_match( "/" . $contact_domain . "/i", $stats_url ) )
					{
						$found = 1;
					}
				}
				
				if( $found )
				{
					$query = $database -> dbquery( "SELECT contactreferrer_id FROM " . DB_PREFIX . "esselbach_ct_contactsreferrers WHERE contactreferrer_month = '" . $contacts_month . "' AND contactreferrer_year = '" . $contacts_year . "' AND contactreferrer_url = '" . $stats_url . "' AND contactreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );
					
					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contactsreferrers SET contactreferrer_count = contactreferrer_count + 1 WHERE contactreferrer_month = '" . $contacts_month . "' AND contactreferrer_year = '" . $contacts_year . "' AND contactreferrer_url = '" . $stats_url . "' AND contactreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_contactsreferrers (contactreferrer_id, contactreferrer_website, contactreferrer_month, contactreferrer_year, contactreferrer_url, contactreferrer_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $contacts_month . "', '" . $contacts_year . "', '" . $stats_url . "', '1')" );
					}
				}
			}
		}
	}

	function smtpmail( $var, $var2, $var3, $var4, $var5, $var6, $var7, $var8, $var9 )
	{
		$smtp_connect = fsockopen( $var, $var2 );
		$smtp_banner = fgets( $smtp_connect, 1024 );
		fputs( $smtp_connect, "HELO " . $var . "\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );
		
		if( substr( $smtp_result, 0, 3 ) != 250 )
		{
			return( $smtp_result );
		}
		
		if( $var3 )
		{
			fputs( $smtp_connect, "AUTH LOGIN\r\n" );
			fputs( $smtp_connect, base64_encode( $var3 ) . "\r\n" );
			fputs( $smtp_connect, base64_encode( $var4 ) . "\r\n" );
			$smtp_result = fgets( $smtp_connect, 1024 );
			
			if( substr( $smtp_result, 0, 3 ) != 334 )
			{
				return( $smtp_result );
			}
		}
		
		fputs( $smtp_connect, "MAIL FROM: <" . $var5 . ">\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );
		
		if( substr( $smtp_result, 0, 3 ) != 334 )
		{
			return( $smtp_result );
		}
		
		fputs( $smtp_connect, "RCPT TO: <" . $var6 . ">\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );
		
		if( substr( $smtp_result, 0, 3 ) != 235 )
		{
			return( $smtp_result );
		}
		
		fputs( $smtp_connect, "DATA\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );
		
		if( substr( $smtp_result, 0, 3 ) != 250 )
		{
			return( $smtp_result );
		}
		
		fputs( $smtp_connect, "Subject: " . $var7 . "\r\n" );
		fputs( $smtp_connect, $var9 . "\r\n\r\n" );
		fputs( $smtp_connect, $var8 . "\r\n" );
		fputs( $smtp_connect, ".\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );
		
		if( substr( $smtp_result, 0, 3 ) != 250 )
		{
			return( $smtp_result );
		}
		
		fputs( $smtp_connect, "QUIT\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );
		
		if( substr( $smtp_result, 0, 3 ) != 354 )
		{
			return( $smtp_result );
		}
		
		fclose( $smtp_connect );
		return( 0 );
	}

	function mailheader( $var, $var2, $var3, $var4 )
	{
		$var = preg_replace( "/\r/", "", $var );
		$var = preg_replace( "/\n/", "", $var );
		$var2 = preg_replace( "/\r/", "", $var2 );
		$var2 = preg_replace( "/\n/", "", $var2 );
		$var3 = preg_replace( "/\r/", "", $var3 );
		$var3 = preg_replace( "/\n/", "", $var3 );
		$var4 = preg_replace( "/\r/", "", $var4 );
		$var4 = preg_replace( "/\n/", "", $var4 );
		$headers = "From: " . $var . " <" . $var2 . ">\r \n";
		$headers .= "To: " . $var3 . " <" . $var4 . ">\r \n";
		$headers .= "Reply-To: " . $var . " <" . $var2 . ">\r \n";
		$headers .= "MIME-Version: 1.0\n";
		$headers .= "Content-type: text/plain; charset=iso-8859-1\n";
		$headers .= "X-Priority: 1\n";
		$headers .= "X-MSMail-Priority: High\n";
		$headers .= "X-Mailer: Esselbach Contentteller CMS";
		return $headers;
	}
	
	function mailheaderhtml( $var, $var2, $var3, $var4 )
	{
		$var = preg_replace( "/\r/", "", $var );
		$var = preg_replace( "/\n/", "", $var );
		$var2 = preg_replace( "/\r/", "", $var2 );
		$var2 = preg_replace( "/\n/", "", $var2 );
		$var3 = preg_replace( "/\r/", "", $var3 );
		$var3 = preg_replace( "/\n/", "", $var3 );
		$var4 = preg_replace( "/\r/", "", $var4 );
		$var4 = preg_replace( "/\n/", "", $var4 );
		$headers = "From: " . $var . " <" . $var2 . ">\r \n";
		$headers .= "To: " . $var3 . " <" . $var4 . ">\r \n";
		$headers .= "Reply-To: " . $var . " <" . $var2 . ">\r \n";
		$headers .= "MIME-Version: 1.0\n";
		$headers .= "Content-type: text/html; charset=iso-8859-1\n";
		$headers .= "X-Priority: 1\n";
		$headers .= "X-MSMail-Priority: High\n";
		$headers .= "X-Mailer: Esselbach Contentteller CMS";
		return $headers;
	}

	function getpage( $var )
	{
		global $database;
		
		if( $var )
		{
			$page_data = explode( ".", $var );
			$page_query = $database -> dbescape( $page_data[ 0 ] );
		}
		else
		{
			$page_query = "";
		}
		
		return $page_query;
	}

	function getpages( $var, $var2 )
	{
		global $database, $security;
		$page_data = explode( ".", $var );
		$page_array = array();
		
		if( preg_match( "/,/i", $page_data[ 0 ] ) )
		{
			$page_opt = explode( ",", $page_data[ 0 ] );
			$page_array[ ] = $database -> dbescape( $page_opt[ 0 ] );
			$page_array[ ] = $security -> checknum( $page_opt[ 1 ] );
		}
		else
		{
			$page_array[ ] = $database -> dbescape( $page_data[ 0 ] );
			$page_array[ ] = $var2;
		}
		
		return $page_array;
	}

	function getinsert( $var, $var2 )
	{
		global $templates, $system, $preferences, $database, $user;
		$insert[ 'page_charset' ] = htmlspecialchars( $var[ 'website_charset' ] );
		$insert[ 'page_rss' ] = "";
		$insert[ 'site_name' ] = $var[ 'website_name' ];
		$insert[ 'site_url' ] = $var[ 'website_url' ];
		$insert[ 'site_logo_path' ] = $var[ 'website_logo_path' ];
		$insert[ 'site_logo_description' ] = $var[ 'website_logo_description' ];
		$insert[ 'site_logo_subtext' ] = $var[ 'website_logo_subtext' ];
		$insert[ 'site_advertisement_header' ] = $var[ 'website_advertisement_header' ];
		$insert[ 'site_advertisement_footer' ] = $var[ 'website_advertisement_footer' ];
		$insert[ 'site_copyright' ] = ( $preferences[ 'website_copyright' ] ) ? "&copy; " . date( "Y" ) . " " . htmlspecialchars( $preferences[ 'website_copyright' ] ) . "<br />" : "" ;
		$insert[ 'site_theme' ] = $var[ 'current_theme' ];
		$insert[ 'param_ext' ] = $var[ 'param_ext' ];
		$insert[ 'param_ct' ] = $var[ 'param_ct' ];
		$insert[ 'param_action' ] = $var[ 'param_action' ];
		$insert[ 'param_jaction' ] = $var[ 'param_jaction' ];
		$insert[ 'param_page' ] = $var[ 'param_page' ];
		$insert[ 'param_jpage' ] = $var[ 'param_jpage' ];
		$insert[ 'param_id' ] = $var[ 'param_id' ];
		$insert[ 'param_jid' ] = $var[ 'param_jid' ];
		$insert[ 'site_tasks' ] = ( $preferences[ 'website_managed_with' ] ) ? "<a href=\"http://www.contentteller.com\"><img src=\"contentteller.php?ct=core&amp;action=tasks" . "\" alt=\"Managed with Contentteller(R) Professional Edition\" /></a>" : "<img src=\"contentteller.php?ct=core&amp;action=tasks" . "\" alt=\"\" />" ;
		
		if( $preferences[ 'user_active' ] )
		{
			if( ( $user[ 'user_username' ] ) && ( $user[ 'user_session' ] ) )
			{
				$query = $database -> dbquery( "SELECT count(userprivatemessage_id) FROM " . DB_PREFIX . "esselbach_ct_usersprivatemessages WHERE userprivatemessage_new = '1' AND userprivatemessage_recipient = '" . $database -> dbescape( $user[ 'user_name' ] ) . "'" );
				list( $pms ) = $database -> dbrow( $query );
				$insert[ 'private_messages' ] = ( $pms ) ? "(" . $pms . ")" : "" ;
				$insert[ 'user_username' ] = $user[ 'user_name' ];
				$insert[ 'site_login' ] = $templates -> exectemplate( $var2[ 'site_login_user_html' ], $var2[ 'site_login_user_php' ], $insert );
			}
			else
			{
				$insert[ 'site_login' ] = $templates -> exectemplate( $var2[ 'site_login_anon_html' ], $var2[ 'site_login_anon_php' ], $insert );
			}
		}
		else
		{
			$insert[ 'site_login' ] = "";
		}
		
		$blocks = $templates -> prepareblocks( $var2[ 'site_block_html' ], $var2[ 'site_block_php' ], $insert );
		
		foreach( $blocks as $block_id => $block_content )
		{
			$insert[ 'site_block_' . $block_id ] = $block_content;
		}
		
		return $insert;
	}

	function unhtmlchars( $var )
	{
		$var = strtr( $var, array_flip( get_html_translation_table( HTML_SPECIALCHARS ) ) );
		return $var;
	}
	
	function geturltitles( $var )
	{
		preg_match_all("/\[url\](.*)\[\/url\]/Ui", $var, $matches, PREG_SET_ORDER);
		
		foreach( $matches as $match )
		{
			if( function_exists( "curl_init" ) )
			{
				$url = curl_init( $match[1] );
				
				if( preg_match( "/https/i", $match[1] ) )
				{
					curl_setopt( $url, CURLOPT_PORT, 443 );
					curl_setopt( $url, CURLOPT_SSL_VERIFYPEER, false );
				}
				
				curl_setopt( $url, CURLOPT_RETURNTRANSFER, 1 );
				curl_setopt( $url, CURLOPT_CONNECTTIMEOUT, 5 );
				curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
				$data = curl_exec( $url );
				curl_close( $url );
			}
			else
			{
				$url = fopen( $match[1], "r" );
				$data = fread( $url, 4096 );
				fclose( $url );
			}
		
			preg_match( "/<title>(.*)<\/title>/i", $data, $title );
		
			if ( $title[1] )
			{
				$var = str_replace( $match[0], "[url=" . $match[1] . "]" . html_entity_decode($title[1]) . "[/url]", $var );
			}
		}
		return $var;
	}

	function datastoreput( $var, $var2 )
	{
		global $config, $database;
		$expire = mktime() + 600;
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_datastore (datastore_id, datastore_query, datastore_website, datastore_data, datastore_expire) VALUES (NULL, '" . $database -> dbescape( $var ) . "', '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $database -> dbescape( $var2 ) . "', '" . $expire . "')" );
	}

	function datastoreget( $var )
	{
		global $config, $database;
		$current = mktime();
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_datastore WHERE datastore_query = '" . $database -> dbescape( $var ) . "' AND datastore_website = '" . intval( $config[ 'WEBSITE' ] ) . "' AND datastore_expire < '" . $current . "'" );
		$query = $database -> dbquery( "SELECT datastore_data FROM " . DB_PREFIX . "esselbach_ct_datastore WHERE datastore_query = '" . $database -> dbescape( $var ) . "' AND datastore_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
		list( $data ) = $database -> dbrow( $query );
		return $data;
	}
	
	function adminhashput()
	{
		global $database, $login_loginname;
		$var = md5( $login_loginname . microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) ) . md5( microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) . $login_loginname );
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_adminsessions SET session_hash = '" . $database -> dbescape( $var ) . "' WHERE session_adminuser = '" . $database -> dbescape( $login_loginname ) . "'");
		
		return $var;
	}
	
	function adminhashget()
	{
		global $database, $login_loginname;
		
		$query = $database -> dbquery( "SELECT session_hash FROM " . DB_PREFIX . "esselbach_ct_adminsessions WHERE session_adminuser = '" . $database -> dbescape( $login_loginname ) . "'");
		if ($database -> dbrows( $query ))
		{
			list( $var ) = $database -> dbrow( $query );
		}
		else
		{
			$var = md5( $login_loginname . microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) ) . md5( microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) . $login_loginname );
		}
		
		return $var;
	}

	function dorand()
	{
		$var = md5( microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) ) . md5( uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) . microtime() );
		return $var;
	}
	
	function doseo( $var )
	{
		$var = str_replace( "&amp;", "&", htmlentities( strtolower( $var ) ) );
		$var = str_replace( array( "&auml;", "&Auml;", "&aacute;", "&Aacute;", "&agrave;", "&Agrave;", "&atilde;", "&Atilde;", "&acirc;", "&Acirc;", "&ccedil;", "&Ccedil;", "&euml;", "&Euml;", "&eacute;", "&Eacute;", "&egrave;", "&Egrave;", "&ecirc;", "&Ecirc;", "&iuml;", "&Iuml;", "&iacute;", "&Iacute;", "&igrave;", "&Igrave;", "&icirc;", "&Icirc;", "&ntilde;", "&Ntilde", "&ouml;", "&Ouml;", "&oacute;", "&ograve;", "&Ograve;", "&otilde;", "&Otilde;", "&ocirc;", "&Ocirc;", "&szlig;", "&uuml;", "&Uuml;", "&uacute;", "&Uacute;", "&ugrave;", "&Ugrave;", "&ucirc;", "&Ucirc;" ), array( "ae", "ae", "a", "a", "a", "a", "a", "a", "a", "a", "c", "c", "e", "e", "e", "e", "e", "e", "e", "e", "i", "i", "i", "i", "i", "i", "i", "i", "n", "n", "oe", "oe", "o", "o", "o", "o", "o", "o", "o", "ss", "ue", "ue", "u", "u", "u", "u", "u", "u" ), $var );
		$var = str_replace( array( ", ", "'", '"', " . ", "!", "$", "^", "*", ";
		", "%", "?", "( ", " )", "~", "@", "#", "[ ", " ]", "<", ">", "\\", "/", ":", "&", " = ", "+", "", ""), "", $var);
		$var = str_replace(array("-", " ", "__"), "_", $var );
		$var = preg_replace( "/(&(amp|gt|lt|quot);|[^a-zA-Z0-9_])+/", "", $var );
		return $var;
	}
}
?>